/*
 * zoom.js
 *
 * マウスダウンで始点を、マウスアップで終点を指定した座標値を
 * ajaxで非同期ﾘｸｴｽﾄで送信します。
 * 要素の座標位置は、ｸﾘｯｸ位置(画面全体に対する座標)から、
 * 要素の位置を引いた値になります。
 * 画像など、ｵﾘｼﾞﾅﾙのｻｲｽﾞとﾌﾞﾗｳｻﾞ上のｻｲｽﾞが異なるｹｰｽもあるため、
 * 要素の幅(width)と高さ(height)、ｸﾘｯｸ座標(始点のX,Y、終点のX,Y)
 * をjson文字列に変換して、/filter にPOST しています。
 */

$(function(){
	$('#img_C').mousedown( function(event) { zoom('0',event); });
	$('#img_C').mouseup(   function(event) { zoom('1',event); });
});

// マウスダウンで始点を記録
var stX = 0;
var stY = 0;

function zoom( flag,event ) {
	// 要素の位置を取得
	let clientRect = event.target.getBoundingClientRect() ;
	let positionX = clientRect.left + window.pageXOffset ;
	let positionY = clientRect.top  + window.pageYOffset ;

	// 要素内におけるクリック位置を計算
	let x = event.pageX - positionX ;
	let y = event.pageY - positionY ;

	// flag は、ダウン=0 , アップ=1
	if( flag == '0' ) {				// マウスダウン時の位置が、開始XY
		stX = x ;
		stY = y ;
	}
	else if( flag == '1' ) {		// マウスアップ時の位置が、終了XY
		let width  = clientRect.width ;
		let height = clientRect.height ;

		// jsonﾃﾞｰﾀの作成
		let data = JSON.stringify({
			width : width  ,
			height: height ,
			stX   : stX ,
			stY   : stY ,
			edX   : x ,
			edY   : y ,
		});

		// ajax で bottle の/filterにPOST する
		$.ajax({
			method: 'POST',
			url: '/filter',
			data: data,
			contentType: 'application/json',
		}).then(
			error => console.log(error)
		);
	}
};
